Class | Sequel::TimestampMigrator
In: | lib/sequel/extensions/migration.rb
Parent: | Migrator

The migrator used if any migration file version appears to be a timestamp. Stores filenames of migration files, and can figure out which migrations have not been applied and apply them, even if earlier migrations are added after later migrations. If you plan to do that, the responsibility is on you to make sure the migrations don‘t conflict. Part of the `migration` extension.

### Methods

new run

### Constants

DEFAULT_SCHEMA_COLUMN | = | :filename
DEFAULT_SCHEMA_TABLE | = | :schema_migrations
Error | = | Migrator::Error

### Attributes

applied_migrations | [R] | Array of strings of applied migration filenames
migration_tuples | [R] | Get tuples of migrations, filenames, and actions for each migration

### Public Class methods

new(db, directory, opts={})

Set up all state for the migrator instance

[Source]

         # File lib/sequel/extensions/migration.rb, line 422
    422:     def initialize(db, directory, opts={})
    423:       super
    424:       @target = opts[:target]
    425:       @applied_migrations = get_applied_migrations
    426:       @migration_tuples = get_migration_tuples
    427:     end

### Public Instance methods

run()

Apply all migration tuples on the database

[Source]

         # File lib/sequel/extensions/migration.rb, line 430
    430:     def run
    431:       migration_tuples.each do |m, f, direction|
    432:         t = Time.now
    433:         db.log_info("Begin applying migration #{f}, direction: #{direction}")
    434:         db.transaction do
    435:           m.apply(db, direction)
    436:           fi = f.downcase
    437:           direction == :up ? ds.insert(column=>fi) : ds.filter(column=>fi).delete
    438:         end
    439:         db.log_info("Finished applying migration #{f}, direction: #{direction}, took #{sprintf('%0.6f', Time.now - t)} seconds")
    440:       end
    441:       nil
    442:     end

[Validate]